var selectedSection = "webforms";
var selectedEntry = null;
var selectedFolder = "";
var total_items = 0;
var current_sort_criteria = "Name";
var current_sort_ascending = true;
var entries = [];
var currentEntry = null;
var concealedFieldCount = 0;
var copyableEntries = {};
var lastSearchString = null;

function profileContentsDidFinishLoading(json) {
	if (!json || json == "") {
		var file = dataFolder + "/contents.js";
		showFatalMessage("Problem loading 1Password data file", "<p>A <a href='" + file + "'>key data file</a> could not be loaded and 1PasswordAnywhere cannot continue without it.</p><p>Please see <a href='http://help.agile.ws/1Password3/1passwordanywhere_troubleshooting.html'>this help guide</a> for troubleshooting tips.</p>");
	}
	var allItems = null;
	
	try {
		allItems = eval(json);
	}
	catch(exc) {
		var error_desc = exc.name + " occurred when parsing contents.js on line #" + exc.line + ":" + exc.message;
		showFatalMessageWithEmailSupportLink("1PasswordAnywhere experienced an error", error_desc);
	}
	
	keychain.setContents(allItems);
	
	renderSectionList();
	selectSection(TYPE_WEBFORMS);
	
	$("search").value = ""; // Sometimes reload does not clear the search criteria 
	lastSearchString = "";
	keychain.rescheduleAutoLogout();
}

function renderSectionList() {
	var h = "";
	h += renderSectionListItem(TYPE_WEBFORMS, "Logins", "logins-20.png");
	h += renderSectionListItem(TYPE_ACCOUNT, "Accounts", "accounts-20.png");
	h += renderSectionListItem(TYPE_IDENTITIES, "Identities", "identities-20.png");
	h += renderSectionListItem(TYPE_NOTES, "Secure Notes", "secure-notes-20.png");
	h += renderSectionListItem(TYPE_SOFTWARE_LICENSES, "Software", "software-20.png");
	h += renderSectionListItem(TYPE_WALLET, "Wallet", "wallet-20.png");
	h += renderSectionListItem(TYPE_PASSWORDS, "Passwords", "passwords-20.png");
	h += renderSectionListItem(TYPE_TRASHED, "Trash", "trash-20.png");
	$('sourcesPane').innerHTML = h;
}

function renderSectionListItem(name, displayName, img) {
	var r = "<li " + sectionOptions(name) + ">";
	r += "<img  src='./style/images/" + img + "' alt='' />" + displayName;
	r += sectionCount(name, displayName);
	r += "</li>";
	return r;
}

function sectionOptions(name) {
	var opts = "id='" + name + "' onclick='selectSection(\"" + name + "\")'"
	
	if (selectedSection == name) {
		opts += " class='selected' "
	}
	return opts;
}

function sectionCount(name, display_name) {
	var result = " <span class='sectionCount'>(" + keychain.itemsOfType(name).length + ")</span>";
	return result;
}

function showAndHideConcealedField(id, clearText, concealed) {
	var revealHide = concealed ? "Reveal" : "Hide";

	// IMPL NOTE: Normally you need not escape HTML values in JS, but innerHTML assignment interprets the JS for some reason.
	// Note the use &apos instead of '. This is important as the interpreter gets confused when evaling innerHTML.
	var htmlValue = clearText.escapeHTML();
	var jsValue = htmlValue.gsub(/\\/, "\\\\");
	jsValue = jsValue.gsub(/"/, "\\\"").gsub(/'/, "&apos;");

	var r = "<table class='hideRevealButton' id='" + id + "'><tr><td><a class='copy'>";	

	var copyImageId = "copyImage-" + id;
	r += copyableHiddenElement(copyImageId, concealedField);
	r += "</a></td>";

	r += "<td><a class='revealButton' href='#' style='text-decoration:none' onclick='toggleVisibilityOfConcealedField(\"" + copyImageId + "\", \"" + jsValue + "\", " + !concealed + ")'>" + revealHide + "</a></td>";
	
	r += "</tr>";
	r += "</table>";

	if ($(id)) $(id).innerHTML = r;
 	
	copyableEntries[copyImageId] = clearText

	return r;
}

// TODO: Do not bother adding elements when running from file:// b/c of stupid default Flash security preference
function copyableHiddenElement(id) {
	var r = "<div style='position:relative'><div class='copy' id='" + id + "'>";
	r += concealedField();
	r += "</div></div>"
	return r;
}

function toggleVisibilityOfConcealedField(id, clearText) {
	if ($(id).innerHTML == clearText) {
		$(id).innerHTML = concealedField();
	}
	else {
		$(id).innerHTML = clearText;
	}
}

function showAndHideConcealedFieldOrig(id, clearText, concealed) {
	var revealHide = concealed ? "Reveal" : "Hide";

	// IMPL NOTE: Normally you need not escape HTML values in JS, but innerHTML assignment interprets the JS for some reason.
	// Note the use &apos instead of '. This is important as the interpreter gets confused when evaling innerHTML.
	var htmlValue = clearText.escapeHTML();
	var jsValue = htmlValue.gsub(/\\/, "\\\\");
	jsValue = jsValue.gsub(/"/, "\\\"").gsub(/'/, "&apos;");

	var r = "<table class='hideRevealButton' id='" + id + "'><tr><td><a class='copy'>";	

	var copyImageId = "copyImage-" + id;
	r += "<div style='position:relative'><div class='copy' id='" + copyImageId + "'>";
	r += concealed ? concealedField() : htmlValue;
	r += "</div></div>"
	
	var copyImage = styleFolder + "/images/copy.png";
//	r += "<div style='position:relative'><div class='copy' id='" + copyImageId + "' style='color:red;'>Copy</div></div>";
	r += "</a></td>";

	r += "<td><a class='revealButton' href='#' style='text-decoration:none' onclick='showAndHideConcealedField(\"" + id + "\", \"" + jsValue + "\", " + !concealed + ")'>" + revealHide + "</a></td>";
	
	r += "</tr>";
	r += "</table>";

	if ($(id)) $(id).innerHTML = r;
 	
	copyableEntries[copyImageId] = clearText

	return r;
}


function enableCopyableEntries() {
	for (copyable in copyableEntries) {
		var clip = new ZeroClipboard.Client();
		clip.setHandCursor( true );
		clip.setText(copyableEntries[copyable]);
		
		var button = $(copyable);
		var container = button.parentNode;
		
		clip.glue( button, container );
	}
}

function concealedField() {
	var r = ""; 
	for (var i=0; i < 10; i++) {
		r += "&bull;";
	}
	return r;
}

function showPassword(data)
{
	if (data.notesPlain && data.notesPlain.length > 0) {
		$('entryNotesDecryptedValue').innerHTML = '<p>' + convertNewLines(data.notesPlain.escapeHTML()) + '</p>';
		$('entryNotesDecryptedValue').parentNode.style.display = "";
	}
	
	var passwd = "<tr><td class='fieldName'>Password</td><td class='fieldValue'>" + data.password.escapeHTML() + "</td></tr>";
	$('dynamicFields').innerHTML = passwd;
}

function convertNewLines(txt) {
	return txt.gsub("\n\r", "\n").gsub("\r\n", "\n").gsub("\r", "\n").gsub("\n", "<br/>");
}

function sortCompareFunction(a, b) {
	if (current_sort_criteria == "Domain") {
		a = a.domain;
		b = b.domain;
	}
	else if (current_sort_criteria == "Modified") {
		a = a.updatedAtMs + "";
		b = b.updatedAtMs + "";
	}
	else {
		a = a.title;
		b = b.title;
	}
	
	var result = 0;
    if ( a.toLowerCase() < b.toLowerCase() ) {
		result = -1;
    }
    else if ( a.toLowerCase() > b.toLowerCase() ) {
		result = 1;
    }

	if (!current_sort_ascending) result = result * -1;
	
	return result;
}

function styleSectionCount(id)
{
	var current_count = $(id + "-count");
	if (!current_count) return;

	var color = "gray";
	var clazz = "itemNumberTotal";
    
	if (id == selectedSection) {
		color = "white"
		clazz = "itemNumberTotalSelected"
    }

	var children = current_count.childNodes;
	children[1].src = "/images/sections/item_number_right_" + color + ".png";
	children[3].setAttribute("class", clazz);
	children[5].src = "/images/sections/item_number_left_" + color + ".png";
}

function styleSection(id) {
	if (id == "" || id.indexOf("folder") == 0) return;
	
	if (id == selectedSection) {
		$(id).className = "selectedSection";
		$(id).childNodes[1].className = "sectionLinkSelected";
	}
	else {
		$(id).className = "";
		$(id).childNodes[1].className = "sectionLink";
	}
	styleSectionCount(id);
}

function selectSection(section_id)
{
	if (selectedFolder != "") $(selectedFolder).setAttribute('class', '');
	
	keychain.rescheduleAutoLogout();
	
	if (selectedSection != section_id)
	{
		selectedSection = section_id;
		renderSectionList();
		displayEntries({'select_first':true});
	}
}

function selectEntry(entry_id)
{
	keychain.rescheduleAutoLogout();
	selectedEntryId = entry_id;
	
	// Deselect the currently highlighted entry
	var highlighted = $$('#listPane .selected');
	for (var i=0; i < highlighted.length; i++) {
		highlighted[i].removeClassName('selected');
	}
	
	$('entry_' + entry_id).addClassName('selected');
	var file = fullKeychainFilePath(entry_id + ".1password");
	loadFile(file, entryDidFinishLoading);
}

function entryDidFinishLoading(json) {
	if (!json || json == "") {
		alert("The data file for this entry could not be loaded.")
		return;
	}
	
	var entry;
	try {
		var json = "(" + json + ")";
		entry = eval(json);
	}
	catch (e) {alert('Error evaluating data for this entry! Error: ' + e);}
	
	selectedEntry = new KeychainItem(entry);
	showEntryDetails();
}

function displayEntries(opts)
{
	var select_first = false;
	if (opts) {
		select_first = opts['select_first']
	}
	
	var all = keychain.itemsOfType(selectedSection);
	var entries = [];

	var s = $("search").value.toLowerCase();
	
	for (var i=0; i<all.length; ++i) {
		var e = all[i];
		if (e.matches(s)) entries.push(e);
	}
	
	entries.sort(sortCompareFunction);
	var i, len = entries.length;
	var displayCount = 0;
	var html = ""
	for (i = 0; i < len; ++i) {
		e = entries[i];
		
		displayCount++;
		var title = e.title;
		var domain = e.domain;
		var date = e.updatedAt;
		var uuid = e.uuid;
		var clazz = "";
		
		html += '<li id="entry_' + uuid + '" onclick="selectEntry(\''+uuid+'\')"><strong>'+title.escapeHTML()+'</strong><br/>'+domain+'</li>';
	}
	$('listPane').innerHTML = html;
	
	if (entries.length == 0) $('detailsPane').innerHTML = null;
	else if (select_first) selectEntry(entries[0].uuid);

	keychain.rescheduleAutoLogout();
}

function showEntryDetails() {
	keychain.rescheduleAutoLogout();
	$('emptyDetailsPane').style.display = "none";
	$('detailsPane').style.display = "";
	copyableEntries = {};
	
	concealedFieldCount = 0;
	
	var decryption_status;
	try { decryption_status = selectedEntry.decrypt() } 
	catch (e) {alert("error " + e);}
	
	if (decryption_status != ERROR_OK) {
		alert("An error occurred while processing item '" + selectedEntry.uuid + "'.\n\n" + decryption_status );
		return;
	}
	
	$('detailsPane').innerHTML = "";
	$('detailsPane').innerHTML = selectedEntry.asHTML();
	enableCopyableEntries();
}

function clearEntryDetails() {
	if ($('listPane')) $('listPane').innerHTML = "";
	if ($('sourcesPane')) $('sourcesPane').innerHTML = "";
	if ($('detailsPane')) $('detailsPane').innerHTML = "";
}

function searchEntries()
{
	if (lastSearchString == $('search').value) return;
	
	displayEntries({'select_first':true});
	lastSearchString = $('search').value;
}
